/* --------------------------------------------------------------
 product_question.js 2016-04-04
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2016 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 --------------------------------------------------------------
 */

/**
 * Widget that updates that opens a lightbox for asking product questions. Sends an e-mail to the shop administrator
 * with the asked question
 */
gambio.widgets.module(
	'product_question',
	
	['xhr'],
	
	function(data) {
		
		'use strict';
		
		// ########## VARIABLE INITIALIZATION ##########
		
		var $this = $(this),
			$body = $('body'),
			defaults = {
				btnOpen:    '.btn-product-question',
				btnClose:   '.btn-close-question-window',
				btnSend:    '.btn-send-question',
				url:        'shop.php?do=ProductQuestion',
				sendUrl:    'shop.php?do=ProductQuestion/Send',
				productId:  0,
				formSelector: '#product-question-form'
			},
			options = $.extend(true, {}, defaults, data),
			module = {};
		
		
		// ########## EVENT HANDLER ##########
		
		var _openModal = function() {
			jse.libs.xhr.get({
				url: options.url+'&productId='+options.productId
			}, true).done(function(result) {
				_closeModal();
				$body.append(result.content);
				window.gambio.widgets.init($('.mfp-wrap'));
			});
		};
		
		var _closeModal = function() {
			$('.mfp-bg').remove();
			$('.mfp-wrap').remove();
		};
		
		var _sendForm = function() {
			var url = options.sendUrl+'&productId='+options.productId,
				data = $(options.formSelector).serialize();
			
			$.post(url, data).done(function(result) {
				_closeModal();
				$body.append(result.content);
				window.gambio.widgets.init($('.mfp-wrap'));
			});
		};
		
		// ########## INITIALIZATION ##########
		
		/**
		 * Init function of the widget
		 * @constructor
		 */
		module.init = function(done) {
			
			$(options.btnOpen).on('click', _openModal);
			$(options.btnSend).on('click', _sendForm);
			$(options.btnClose).on('click', _closeModal);
			
			done();
			
		};
		
		// Return data to widget engine
		return module;
	});